/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;



import TestPackage.TestVehicle.TestShip;
import org.semanticweb.owlapi.expression.ParserException;
import org.semanticweb.owlapi.model.OWLNamedIndividual;
import java.util.Set;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.util.AutoIRIMapper;
import java.io.File;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * Execute TestPackage.TestVehicle first!
 * @author ohlbach
 */
public class DelayedSynchronisationTest {
    static J2OManager manager;
    static J2OOntologyManager omg;
    static J2OClassManager clm;
    static J2OIndividualManager img;
    
    public DelayedSynchronisationTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        
        manager = new J2OManager("TestManager",J2OManager.Status.RUN,true);
        manager.getLogger().activateInfo(false);
   
        AutoIRIMapper  iriMapper = new AutoIRIMapper( new File("build/test/classes/TestPackage"),true);
        omg = manager.getOntologyManager();
        omg.addIRIMapper(iriMapper);
        
        clm = manager.getClassManager();
        String name = "build/test/classes/TestPackage/AmphibiousVehicle.owl";
        OWLOntology extOntology = omg.loadExtensionOntology(name);
        
        
        J2OCompiler comp = manager.getCompiler();
        comp.class2OWL(TestShip.class);
        comp.finishTranslation();  
         
        img = manager.getIndvidualManager(); 
        clm.activateSynchronisation(TestShip.class);
        //omg.setReasoner("FaCT++", true, false, 10000);
        
        }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    /**
     * Test of apply method, of class Function.
     */
    @Test
    public void testDelayedSynchronisation() throws ParserException {
        System.out.println("delayed synchronisation");
        
        TestShip Herbie = new TestShip("Herbie");
        IndividualWrapper herbie = img.object2OWL(Herbie);
        
        TestShip Charly = new TestShip("Charly");
        IndividualWrapper charly = img.object2OWL(Charly);
         
        TestShip Billy = new TestShip("Billy");
        IndividualWrapper billy = img.object2OWL(Billy);
    
        Herbie.addOwner("Mayer");
        Herbie.addPredecessor(Billy);
        Herbie.setKnots(10.0f);
        
        Set<OWLNamedIndividual> individuals = 
                omg.getInstances("hasPredecessor some Vehicle and hasOwner value \"Mayer\"");
        assertFalse(individuals.isEmpty());
        individuals = omg.getInstances("speed value 10.0f");
        assertFalse(individuals.isEmpty());
        
        herbie.deactivateSynchronisation(false);
        
        Herbie.addOwner("Miller");
        Herbie.addPredecessor(Charly);
        Herbie.setKnots(20.0f);
        
        individuals = omg.getInstances("hasPredecessor some {Charly} and hasOwner value \"Miller\"");
        assertTrue(individuals.isEmpty());
        
        individuals = omg.getInstances("speed value 10.0f");
        assertFalse(individuals.isEmpty());
        
        herbie.activateSynchronisation(false);
        
        individuals = omg.getInstances("hasPredecessor some {Charly} and hasOwner value \"Miller\"");
        assertFalse(individuals.isEmpty());
        
        assertTrue(Herbie == img.getIWR(individuals.iterator().next()).getFirstObject());
       
        individuals = omg.getInstances("speed value 10.0f");
        assertTrue(individuals.isEmpty());
       
        individuals = omg.getInstances("speed value 20.0f");
        assertFalse(individuals.isEmpty());
       
        //omg.saveExtensionOntology();
        
    }

    
}
