/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Java2OWL;


import java.lang.reflect.Method;
import java.util.*;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import org.semanticweb.owlapi.model.*;

/**
 *
 * @author ohlbach
 */
public class PropertyWrapperTest {
    static J2OManager manager;
    static Logging logger;
    static OWLOntologyManager ontologyManager;
    static OWLDataFactory dataFactory;
    static OWLClass ocl;
    static Class jcl;
     
    static ArrayList<OWLAxiom> axioms;
    
    public PropertyWrapperTest() {
    }

    static Class pmt = PropertyWrapperTest.class;
    static Class pmti = PropertyWrapperTest.Inner.class;
    static Class pmtm = PropertyWrapperTest.InnerMap.class;
     
    @J2OWLProperty(setter = "setBoolean")
    public boolean isBoolean(){return true;}
    static Method isBooleanM;
    static PropertyWrapper isBooleanMD;
    
    public void setBoolean(boolean a){}
    static Method setBooleanM; 
    
    @J2OWLProperty(adder = "addBooleanA,addBooleanAB")
    public boolean[] getBooleanA(){return null;}
    static Method getBooleanAM; 
    static PropertyWrapper getBooleanAMD;
    
    public void addBooleanAB(boolean a){}
    public void addBooleanA(boolean a, int index){}
    static Method addBooleanAM; 
      
    @J2OWLProperty(adder = "addBooleanL")
    public List<Boolean> getBooleanL(){return null;}
    static Method getBooleanLM; 
    static PropertyWrapper getBooleanLMD;
    
    @J2OWLProperty
    public void addBooleanL(boolean a){}
    static Method addBooleanLM; 
    
    @J2OWLProperty
    public List<Boolean>[] getBooleanAL(){return null;}
    static Method getBooleanALM; 
    static PropertyWrapper getBooleanALMD;
    
    
    @J2OWLProperty(setter = "setint")
    public int getint(){return 0;}
    static Method getintM; 
    static PropertyWrapper getintMD;
    
    public void setint(int i){}
    static Method setintM; 
    
    @J2OWLProperty(setter = "toInt")
    public Integer getInt(){return 0;}
    static Method getIntM; 
    static PropertyWrapper getIntMD;
      
    public void toInt(Integer i){}
    static Method toIntM; 
     
    @J2OWLProperty(setter = "setbyte")
    public byte getbyte(){return 0;}
    static Method getbyteM; 
    static PropertyWrapper getbyteMD;
    
    public void setbyte(byte i){}
    static Method setbyteM; 
    
    @J2OWLProperty(setter = "setShort")
    public Short getShort(){return 0;}
    static Method getShortM; 
    static PropertyWrapper getShortMD;
    
    public void setShort(Short i){}
    static Method setShortM; 
    
    @J2OWLProperty(name = "hasFloat")
    public float[] getfloat(){return null;}
    static Method getfloatM; 
    static PropertyWrapper getfloatMD;
    
    @J2OWLProperty
    public Float[] getFloat(){return null;}
    static Method getFloatM; 
    static PropertyWrapper getFloatMD;
    
    
    @J2OWLProperty(local = true, adder="addDouble")
    public List<Double> getDouble(){return null;}
    static Method getDoubleM; 
    static PropertyWrapper getDoubleMD;
 
    
    public void addDouble(Double i){}
    static Method addDoubleM; 
       
    @J2OWLProperty()
    public Double[] getDoubleA() {return null;}
    static Method getDoubleAM; 
    static PropertyWrapper getDoubleAMD;
 
    
    @J2OWLProperty(local = true)
    public List<Double>[] getDoubleAL(){return null;}
    static Method getDoubleALM; 
    static PropertyWrapper getDoubleALMD;
    
    @J2OWLProperty(setter="setPM")
    public PropertyWrapperTest getPM() {return null;} 
    static Method getPMM; 
    static PropertyWrapper getPMMD;
    
    public void setPM(PropertyWrapperTest i){}
    static Method setPMM; 
    
    @J2OWLProperty(symmetric=true,reflexive=true,transitive=true)
    public PropertyWrapperTest[] getPMA() {return null;} 
    static Method getPMAM; 
    static PropertyWrapper getPMAMD;
 
    
    @J2OWLProperty(symmetric=true,asymmetric=true,adder="addPMS")
    public Set<PropertyWrapperTest> getPMS() {return null;} 
    static Method getPMSM; 
    static PropertyWrapper getPMSMD;
 
    
    public void addPMS(PropertyWrapperTest i) {}
    static Method addPMSM; 
    static PropertyWrapper addPMSMD;
  
    class Inner {
        @J2OWLProperty(name = "getPMS",transitive=true)
        public Set<PropertyWrapperTest> getPMSI() {return null;} 
        
        @J2OWLProperty
        public Short getShort(){return 0;}
    }
    
    static Method getPMSIM; 
    static Method getShortIM; 
    static Class pmcl = PropertyWrapperTest.class;
    static Class ipmcl = PropertyWrapperTest.Inner.class;
    
    //  -----------------  Testing Functional Mappers ------------------------------- //
    
    @J2OWLProperty(setter = "setMSI", adder="addMSI", remover = "removeMSI", clearer="clearMSI", getKey="getKey")
    public Map<String, Integer> getMSI() {return null;} 
    static Method getMSIM; 
    static PropertyWrapper getMSIMD;
    
    public void setMSI(Map<String, Integer> m){} static Method setMSIM; 
    public void addMSI(String s,Integer i){}     static Method addMSIM; 
    public void removeMSI(String s){}            static Method removeMSIM; 
    public void clearMSI(){}                     static Method clearMSIM; 
    public void getKey(String s){}               static Method getKeyM; 
    
     //  -----------------  Testing Relational Mappers ------------------------------- //
    
    @J2OWLProperty(setter = "setMSIL", adder="addMSIL,addMSILL", 
            remover = "removeMSIL,removeMSILL", clearer="clearMSIL", getKey="getKeyL")
    public Map<String, List<Integer>> getMSIL() {return null;} 
    static Method getMSILM; 
    static PropertyWrapper getMSILMD;
    
    public void setMSIL(Map<String, List<Integer>> m){} static Method setMSILM; 
    public void addMSIL(String s,Integer i){}     static Method addMSILM;  
    public void addMSILL(String s,List<Integer> i){}     static Method addMSILLM; 
    public void removeMSIL(String s){}            static Method removeMSILM; 
    public void removeMSILL(String s, Integer i){}static Method removeMSILLM; 
    public void clearMSIL(){}                     static Method clearMSILM; 
    public void getKeyL(String s){}               static Method getKeyLM; 
    
    
    static class InnerMap {
        
        @J2OWLProperty(setter = "setIMSIL", adder="addIMSIL,addIMSILL", 
            remover = "removeIMSIL,removeIMSILL", clearer="clearIMSIL", getKey="getIKeyL")
        public Map<String, List<Integer>> getIMSIL() {return null;} 
    
        public void setIMSIL(Map<String, List<Integer>> m){} 
        public void addIMSIL(String s,Integer i){}     
        public void addIMSILL(String s,List<Integer> i){}     
        public void removeIMSIL(String s){}            
        public void removeIMSILL(String s, Integer i){}
        public void clearIMSIL(){}         
        public void getIKeyL(String s){}                     
    }
        static Method getIMSILM;
        static Method setIMSILM;
        static Method addIMSILM;
        static Method addIMSILLM;
        static Method removeIMSILM;
        static Method removeIMSILLM;
        static Method clearIMSILM;
        static Method clearIMSILLM;
        static Method getIKeyLM;
    
    
    
     //  -----------------  Testing Relational MappersObject ------------------------------- //
    
    @J2OWLProperty(setter = "setMSILO", adder="addMSILO,addMSILLO", 
            remover = "removeMSILO,removeMSILLO", clearer="clearMSILO", getKey="getKeyLO")
    public Map<Locale, List<PropertyWrapperTest>> getMSILO() {return null;} 
                                                  
    static Method getMSILOM; 
    static PropertyWrapper getMSILOMD;
    
    public void setMSILO(Map<Locale, List<PropertyWrapperTest>> m){} static Method setMSILOM; 
    public void addMSILO(Locale s,PropertyWrapperTest i){}     static Method addMSILOM;  
    public void addMSILLO(Locale s,List<PropertyWrapperTest> i){}     static Method addMSILLOM; 
    public void removeMSILO(Locale s){}            static Method removeMSILOM; 
    public void removeMSILLO(Locale s, PropertyWrapperTest i){}static Method removeMSILLOM; 
    public void clearMSILO(){}                     static Method clearMSILOM; 
    public void getKeyLO(Locale s){}               static Method getKeyLOM; 
    
    
    
    
    
    @BeforeClass
    public static void setUpClass() throws Exception {
        manager = new J2OManager("TestManager",J2OManager.Status.COMPILE,true);
        logger = manager.getLogger();
        ontologyManager = manager.getOntologyManager().ontologyManager;
        dataFactory = J2OOntologyManager.dataFactory;
        ocl = dataFactory.getOWLClass(IRI.create("testowlclass"));
        try {
        isBooleanM = pmt.getDeclaredMethod("isBoolean");
        setBooleanM = pmt.getDeclaredMethod("setBoolean",boolean.class);
        
        getBooleanAM = pmt.getDeclaredMethod("getBooleanA");
        addBooleanAM = pmt.getDeclaredMethod("addBooleanA",boolean.class,int.class);
        getBooleanLM = pmt.getDeclaredMethod("getBooleanL");
        addBooleanLM = pmt.getDeclaredMethod("addBooleanL",boolean.class);
        getBooleanALM = pmt.getDeclaredMethod("getBooleanAL");
        getintM = pmt.getDeclaredMethod("getint");
        setintM = pmt.getDeclaredMethod("setint",int.class);
        getIntM = pmt.getDeclaredMethod("getInt");
        toIntM = pmt.getDeclaredMethod("toInt",Integer.class);
        getbyteM = pmt.getDeclaredMethod("getbyte");
        setbyteM = pmt.getDeclaredMethod("setbyte",byte.class);
        getShortM = pmt.getDeclaredMethod("getShort");
        setShortM = pmt.getDeclaredMethod("setShort",Short.class);
        getfloatM = pmt.getDeclaredMethod("getfloat");
        getFloatM = pmt.getDeclaredMethod("getFloat");
        getDoubleM = pmt.getDeclaredMethod("getDouble");
        addDoubleM = pmt.getDeclaredMethod("addDouble",Double.class);
        getDoubleAM = pmt.getDeclaredMethod("getDoubleA");
        getDoubleALM = pmt.getDeclaredMethod("getDoubleAL");
        getPMM = pmt.getDeclaredMethod("getPM");
        setPMM = pmt.getDeclaredMethod("setPM",PropertyWrapperTest.class);
        getPMAM = pmt.getDeclaredMethod("getPMA");
        getPMSM = pmt.getDeclaredMethod("getPMS");
        addPMSM = pmt.getDeclaredMethod("addPMS",pmt);
        
        getPMSIM = pmti.getDeclaredMethod("getPMSI");
        getShortIM = pmti.getDeclaredMethod("getShort");
        
        getMSIM = pmt.getDeclaredMethod("getMSI");
        setMSIM = pmt.getDeclaredMethod("setMSI",Map.class);
        addMSIM = pmt.getDeclaredMethod("addMSI",String.class,Integer.class);
        removeMSIM = pmt.getDeclaredMethod("removeMSI",String.class);
        clearMSIM = pmt.getDeclaredMethod("clearMSI");
        getKeyM=  pmt.getDeclaredMethod("getKey",String.class);
        
        getMSILM = pmt.getDeclaredMethod("getMSIL");
        setMSILM = pmt.getDeclaredMethod("setMSIL",Map.class);
        addMSILM =  pmt.getDeclaredMethod("addMSIL",String.class,Integer.class);
        addMSILLM =  pmt.getDeclaredMethod("addMSILL",String.class,List.class);
        removeMSILM=  pmt.getDeclaredMethod("removeMSIL",String.class);
        removeMSILLM=  pmt.getDeclaredMethod("removeMSILL",String.class,Integer.class);
        clearMSILM  =  pmt.getDeclaredMethod("clearMSIL");
        getKeyLM=  pmt.getDeclaredMethod("getKeyL",String.class);
    
        getIMSILM = pmtm.getDeclaredMethod("getIMSIL");
        setIMSILM = pmtm.getDeclaredMethod("setIMSIL",Map.class);
        addIMSILM =  pmtm.getDeclaredMethod("addIMSIL",String.class,Integer.class);
        addIMSILLM =  pmtm.getDeclaredMethod("addIMSILL",String.class,List.class);
        removeIMSILM=  pmtm.getDeclaredMethod("removeIMSIL",String.class);
        removeIMSILLM=  pmtm.getDeclaredMethod("removeIMSILL",String.class,Integer.class);
        clearIMSILM  =  pmtm.getDeclaredMethod("clearIMSIL");
        getIKeyLM=  pmtm.getDeclaredMethod("getIKeyL",String.class);
    
        
        
        
        getMSILOM = pmt.getDeclaredMethod("getMSILO");
            
        setMSILOM = pmt.getDeclaredMethod("setMSILO",Map.class);
        addMSILOM = pmt.getDeclaredMethod("addMSILO",Locale.class,PropertyWrapperTest.class);
        addMSILLOM = pmt.getDeclaredMethod("addMSILLO",Locale.class,List.class);
        removeMSILOM = pmt.getDeclaredMethod("removeMSILO",Locale.class);
        removeMSILLOM = pmt.getDeclaredMethod("removeMSILLO",Locale.class,PropertyWrapperTest.class);
        clearMSILOM = pmt.getDeclaredMethod("clearMSILO");
        getKeyLOM = pmt.getDeclaredMethod("getKeyLO",Locale.class); 
        
        manager.setClassManager(new ClassMapperTest());
        
        //M = pmt.getDeclaredMethod("");
        
        
        }
        catch(Exception ex) {System.out.println(ex);}   
    }
    
    static class ClassMapperTest extends J2OClassManager {

        @Override
        public OWLClass getOWLClass(Class jcl, boolean direct, boolean remember) {
            String name =jcl.getSimpleName();
            return dataFactory.getOWLClass(IRI.create(name+"_owl"));
        }
    }
    
    
    OWLProperty createOWLProperty(String name, boolean isDataProperty) {
        IRI iri = IRI.create(name);
        return isDataProperty ? dataFactory.getOWLDataProperty(iri) : dataFactory.getOWLObjectProperty(iri);}

   void setProperty(PropertyWrapper pmd) {
        IRI iri = IRI.create(pmd.getName());
        pmd.setProperty(pmd.isDataProperty() ? dataFactory.getOWLDataProperty(iri) : 
                dataFactory.getOWLObjectProperty(iri),false);}

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

    
    @Test
    public void testisBoolean() throws J2OException {
       System.out.println("isBoolean");
       isBooleanMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,isBooleanM,manager);
       assertEquals("isBoolean",isBooleanMD.getName());
       assertTrue(isBooleanMD.isDataProperty());
       assertTrue(isBooleanMD.isFunctional());
       assertFalse(isBooleanMD.isAsymmetric());
       assertFalse(isBooleanMD.isSymmetric());
       assertFalse(isBooleanMD.isIrreflexive());
       assertFalse(isBooleanMD.isReflexive()); 
       assertFalse(isBooleanMD.isTransitive());
       assertEquals(isBooleanM,isBooleanMD.getGetter(pmt));
       assertEquals(setBooleanM,isBooleanMD.getSetter(pmt));
       setProperty(isBooleanMD);
       axioms = isBooleanMD.createOWLAxioms();
       assertEquals(axioms.size(),3);
       assertEquals(axioms.get(1).toString(),"DataPropertyRange(<isBoolean> xsd:boolean)");
       assertEquals(axioms.get(2).toString(),"FunctionalDataProperty(<isBoolean>)");       
    } 
    
    @Test
    public void testgetBooleanA() throws J2OException {
       System.out.println("getBooleanA");
       getBooleanAMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getBooleanAM,manager);
       assertEquals(getBooleanAMD.getName(),"getBooleanA");
       assertTrue(getBooleanAMD.isDataProperty());
       assertFalse(getBooleanAMD.isFunctional());
       assertFalse(getBooleanAMD.isAsymmetric());
       assertFalse(getBooleanAMD.isSymmetric());
       assertFalse(getBooleanAMD.isIrreflexive());
       assertFalse(getBooleanAMD.isReflexive()); 
       assertFalse(getBooleanAMD.isTransitive());
       assertEquals(getBooleanAM,getBooleanAMD.getGetter(pmt));
       assertNull(getBooleanAMD.getSetter(pmt));
       setProperty(getBooleanAMD);
       axioms = getBooleanAMD.createOWLAxioms();
       assertEquals(axioms.size(),2);
       assertEquals(axioms.get(1).toString(),"DataPropertyRange(<getBooleanA> xsd:boolean)");
    } 
    
    @Test
    public void testgetBooleanL() throws J2OException {
       System.out.println("getBooleanL");
       getBooleanLMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getBooleanLM,manager);
       assertEquals("getBooleanL",getBooleanLMD.getName());
       assertTrue(getBooleanLMD.isDataProperty());
       assertFalse(getBooleanLMD.isFunctional());
       assertFalse(getBooleanLMD.isAsymmetric());
       assertFalse(getBooleanLMD.isSymmetric());
       assertFalse(getBooleanLMD.isIrreflexive());
       assertFalse(getBooleanLMD.isReflexive()); 
       assertFalse(getBooleanLMD.isTransitive());
       assertEquals(getBooleanLM,getBooleanLMD.getGetter(pmt));
       assertNull(getBooleanLMD.getSetter(pmt));
       setProperty(getBooleanLMD);
       axioms = getBooleanLMD.createOWLAxioms();
       assertEquals(2,axioms.size());
       assertEquals("DataPropertyRange(<getBooleanL> xsd:boolean)",axioms.get(1).toString());
    } 
    
    @Test
    public void testgetBooleanAL() {
       System.out.println("getBooleanAL");
       manager.setDebugMode(false);
       try {getBooleanALMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getBooleanALM,manager);}
       catch(J2OException ex) { manager.setDebugMode(true); return;}
       fail("J2OExcpeption not caught.");
        manager.setDebugMode(true);
    } 
    
    @Test
    public void testgetint() throws J2OException {
       System.out.println("getint");
       getintMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getintM,manager);
       assertEquals("getint",getintMD.getName());
       assertTrue(getintMD.isDataProperty());
       assertTrue(getintMD.isFunctional());
       assertFalse(getintMD.isAsymmetric());
       assertFalse(getintMD.isSymmetric());
       assertFalse(getintMD.isIrreflexive());
       assertFalse(getintMD.isReflexive()); 
       assertFalse(getintMD.isTransitive());
       assertEquals(getintM,getintMD.getGetter(pmt));
       assertEquals(setintM,getintMD.getSetter(pmt));
       setProperty(getintMD);
       axioms = getintMD.createOWLAxioms();
       assertEquals(3,axioms.size());
       assertEquals("[Declaration(DataProperty(<getint>)), DataPropertyRange(<getint> xsd:integer), FunctionalDataProperty(<getint>)]",axioms.toString());
    } 
    
    @Test
    public void testgetInt() throws J2OException {
       System.out.println("getInt");
       getIntMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getIntM,manager);
       assertEquals("getInt",getIntMD.getName());
       assertTrue(getIntMD.isDataProperty());
       assertTrue(getIntMD.isFunctional());
       assertFalse(getIntMD.isAsymmetric());
       assertFalse(getIntMD.isSymmetric());
       assertFalse(getIntMD.isIrreflexive());
       assertFalse(getIntMD.isReflexive()); 
       assertFalse(getIntMD.isTransitive());
       assertEquals(getIntM,getIntMD.getGetter(pmt));
       assertEquals(toIntM,getIntMD.getSetter(pmt));
       setProperty(getIntMD);
       axioms = getIntMD.createOWLAxioms();
       assertEquals(3,axioms.size());
       assertEquals("[Declaration(DataProperty(<getInt>)), DataPropertyRange(<getInt> xsd:integer), FunctionalDataProperty(<getInt>)]",axioms.toString());
    } 
    
    @Test
    public void testgetbyte() throws J2OException {
       System.out.println("getbyte");
       getbyteMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getbyteM,manager);
       assertEquals("getbyte",getbyteMD.getName());
       assertTrue(getbyteMD.isDataProperty());
       assertTrue(getbyteMD.isFunctional());
       assertFalse(getbyteMD.isAsymmetric());
       assertFalse(getbyteMD.isSymmetric());
       assertFalse(getbyteMD.isIrreflexive());
       assertFalse(getbyteMD.isReflexive()); 
       assertFalse(getbyteMD.isTransitive());
       assertEquals(getbyteM,getbyteMD.getGetter(pmt));
       assertEquals(setbyteM,getbyteMD.getSetter(pmt));
       setProperty(getbyteMD);
       axioms = getbyteMD.createOWLAxioms();
       assertEquals(3,axioms.size());
       assertEquals("[Declaration(DataProperty(<getbyte>)), DataPropertyRange(<getbyte> xsd:byte), FunctionalDataProperty(<getbyte>)]",axioms.toString());
    } 
    @Test
    public void testgetShort() throws J2OException {
       System.out.println("getShort");
       getShortMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getShortM,manager);
       assertEquals("getShort",getShortMD.getName());
       assertTrue(getShortMD.isDataProperty());
       assertTrue(getShortMD.isFunctional());
       assertFalse(getShortMD.isAsymmetric());
       assertFalse(getShortMD.isSymmetric());
       assertFalse(getShortMD.isIrreflexive());
       assertFalse(getShortMD.isReflexive()); 
       assertFalse(getShortMD.isTransitive());
       assertEquals(getShortM,getShortMD.getGetter(pmt));
       assertEquals(setShortM,getShortMD.getSetter(pmt));
       setProperty(getShortMD);
       axioms = getShortMD.createOWLAxioms();
       assertEquals(3,axioms.size());   
       assertEquals("[Declaration(DataProperty(<getShort>)), DataPropertyRange(<getShort> xsd:short), FunctionalDataProperty(<getShort>)]",axioms.toString());
       getShortMD.join(ipmcl,getShortIM);
        
       assertTrue(getShortMD.isDataProperty());
       assertTrue(getShortMD.isFunctional());
       assertFalse(getShortMD.isAsymmetric());
       assertFalse(getShortMD.isSymmetric());
       assertFalse(getShortMD.isIrreflexive());
       assertFalse(getShortMD.isReflexive()); 
       assertFalse(getShortMD.isTransitive());
       assertEquals(getShortIM,getShortMD.getGetter(pmti));
       
       axioms = getShortMD.createOWLAxioms();
       assertEquals(3,axioms.size());
       assertEquals("[Declaration(DataProperty(<getShort>)), DataPropertyRange(<getShort> xsd:short), FunctionalDataProperty(<getShort>)]",axioms.toString());
    } 
    @Test
    public void testgetfloat() throws J2OException {
       System.out.println("getfloat");
       getfloatMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getfloatM,manager);
       assertEquals("hasFloat",getfloatMD.getName());
       assertTrue(getfloatMD.isDataProperty());
       assertFalse(getfloatMD.isFunctional());
       assertFalse(getfloatMD.isAsymmetric());
       assertFalse(getfloatMD.isSymmetric());
       assertFalse(getfloatMD.isIrreflexive());
       assertFalse(getfloatMD.isReflexive()); 
       assertFalse(getfloatMD.isTransitive());
       assertEquals(getfloatM,getfloatMD.getGetter(pmt));
       assertNull(getfloatMD.getSetter(pmt));
       setProperty(getfloatMD);
       axioms = getfloatMD.createOWLAxioms();
       assertEquals(2,axioms.size());
       assertEquals("[Declaration(DataProperty(<hasFloat>)), DataPropertyRange(<hasFloat> xsd:float)]",axioms.toString());
    } 
    @Test
    public void testgetFloat() throws J2OException {
       System.out.println("getFloat");
       getFloatMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getFloatM,manager);
       assertEquals("getFloat",getFloatMD.getName());
       assertTrue(getFloatMD.isDataProperty());
       assertFalse(getFloatMD.isFunctional());
       assertFalse(getFloatMD.isAsymmetric());
       assertFalse(getFloatMD.isSymmetric());
       assertFalse(getFloatMD.isIrreflexive());
       assertFalse(getFloatMD.isReflexive()); 
       assertFalse(getFloatMD.isTransitive());
       assertEquals(getFloatM,getFloatMD.getGetter(pmt));
       assertNull(getFloatMD.getSetter(pmt));
       setProperty(getFloatMD);
       axioms = getFloatMD.createOWLAxioms();
       assertEquals(2,axioms.size());
       assertEquals("[Declaration(DataProperty(<getFloat>)), DataPropertyRange(<getFloat> xsd:float)]",axioms.toString());
    } 
    @Test
    public void testgetDouble() throws J2OException {
       System.out.println("getDouble");
       getDoubleMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getDoubleM,manager);
       assertEquals("PropertyWrapperTest_getDouble",getDoubleMD.getName());
       assertTrue(getDoubleMD.isDataProperty());
       assertFalse(getDoubleMD.isFunctional());
       assertFalse(getDoubleMD.isAsymmetric());
       assertFalse(getDoubleMD.isSymmetric());
       assertFalse(getDoubleMD.isIrreflexive());
       assertFalse(getDoubleMD.isReflexive()); 
       assertFalse(getDoubleMD.isTransitive());
       assertEquals(getDoubleM,getDoubleMD.getGetter(pmt));
       assertEquals(addDoubleM,getDoubleMD.getAdder(pmt));
       setProperty(getDoubleMD);
       axioms = getDoubleMD.createOWLAxioms();
       assertEquals(2,axioms.size());
       assertEquals("[Declaration(DataProperty(<PropertyWrapperTest_getDouble>)), DataPropertyRange(<PropertyWrapperTest_getDouble> xsd:double)]",axioms.toString());
    } 
    @Test
    public void testgetDoubleA() throws J2OException {
       System.out.println("getDoubleA");
       getDoubleAMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getDoubleAM,manager);
       assertEquals("getDoubleA",getDoubleAMD.getName());
       assertTrue(getDoubleAMD.isDataProperty());
       assertFalse(getDoubleAMD.isFunctional());
       assertFalse(getDoubleAMD.isAsymmetric());
       assertFalse(getDoubleAMD.isSymmetric());
       assertFalse(getDoubleAMD.isIrreflexive());
       assertFalse(getDoubleAMD.isReflexive()); 
       assertFalse(getDoubleAMD.isTransitive());
       assertEquals(getDoubleAM,getDoubleAMD.getGetter(pmt));
       assertNull(getDoubleAMD.getSetter(pmt));
       setProperty(getDoubleAMD);
       axioms = getDoubleAMD.createOWLAxioms();
       assertEquals(2,axioms.size());
       assertEquals("[Declaration(DataProperty(<getDoubleA>)), DataPropertyRange(<getDoubleA> xsd:double)]",axioms.toString());
    } 
    
    @Test
    public void testgetDoubleAL() {
       System.out.println("getDoubleAL");
       manager.setDebugMode(false);
       try {getDoubleALMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getDoubleALM,manager);}
       catch(J2OException ex) {manager.setDebugMode(true); return;}
       fail("J2OExcpeption not caught.");
       manager.setDebugMode(true);
    } 
    
    @Test
    public void testgetPM() throws J2OException {
       System.out.println("getPM");
       getPMMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getPMM,manager);
       assertEquals("getPM",getPMMD.getName());
       assertFalse(getPMMD.isDataProperty());
       assertTrue(getPMMD.isFunctional());
       assertFalse(getPMMD.isAsymmetric());
       assertFalse(getPMMD.isSymmetric());
       assertFalse(getPMMD.isIrreflexive());
       assertFalse(getPMMD.isReflexive()); 
       assertFalse(getPMMD.isTransitive());
       assertEquals(getPMM,getPMMD.getGetter(pmt));
       assertEquals(setPMM,getPMMD.getSetter(pmt));
       setProperty(getPMMD);
       axioms = getPMMD.createOWLAxioms();
       assertEquals(3,axioms.size());
       assertEquals("[Declaration(ObjectProperty(<getPM>)), ObjectPropertyRange(<getPM> <PropertyWrapperTest_owl>), FunctionalObjectProperty(<getPM>)]",axioms.toString());
    } 
    
    @Test
    public void testgetPMA() throws J2OException {
       System.out.println("getPMA");
       getPMAMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getPMAM,manager);
       assertEquals("getPMA",getPMAMD.getName());
       assertFalse(getPMAMD.isDataProperty());
       assertFalse(getPMAMD.isFunctional());
       assertFalse(getPMAMD.isAsymmetric());
       assertTrue(getPMAMD.isSymmetric());
       assertFalse(getPMAMD.isIrreflexive());
       assertTrue(getPMAMD.isReflexive()); 
       assertTrue(getPMAMD.isTransitive());
       assertEquals(getPMAM,getPMAMD.getGetter(pmt));
       assertNull(getPMAMD.getSetter(pmt));
       setProperty(getPMAMD);
       axioms = getPMAMD.createOWLAxioms();
       assertEquals(5,axioms.size());
       assertEquals("[Declaration(ObjectProperty(<getPMA>)), ObjectPropertyRange(<getPMA> <PropertyWrapperTest_owl>), ReflexiveObjectProperty(<getPMA>), SymmetricObjectProperty(<getPMA>), TransitiveObjectProperty(<getPMA>)]",axioms.toString());
    } 
    @Test
    public void testgetPMS() throws J2OException {
       System.out.println("getPMS");
       manager.setDebugMode(false);
       try{
       getPMSMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getPMSM,manager);}
       catch(Exception ex) {System.out.println(ex.getMessage()); manager.setDebugMode(true);return;}
       manager.setDebugMode(true);
       assertTrue(false);
    } 
    
    @Test
    public void testgetMSI() throws J2OException {
       System.out.println("getMSI");
       getMSIMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getMSIM,manager);
       assertTrue(getMSIMD.isFunctional());
       assertTrue(getMSIMD.isMapper());
       assertTrue(getMSIMD.isDataProperty());
       assertEquals(getMSIM, getMSIMD.getGetter(pmcl));
       assertEquals(setMSIM, getMSIMD.getSetter(pmcl));
       assertEquals(addMSIM, getMSIMD.getAdder(pmcl));
       assertEquals(getKeyM, getMSIMD.getGetKey(pmcl));
       
       //System.out.println(getMSIMD);
    }
    
    @Test
    public void testgetMSIL() throws J2OException {
       System.out.println("getMSIL");
       getMSILMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getMSILM,manager);
       assertFalse(getMSILMD.isFunctional());
       assertTrue(getMSILMD.isMapper());
       assertTrue(getMSILMD.isDataProperty());
       assertEquals(getMSILM, getMSILMD.getGetter(pmcl));
       assertEquals(setMSILM, getMSILMD.getSetter(pmcl));
       assertEquals(addMSILM, getMSILMD.getAdder(pmcl));
       assertEquals(getKeyLM, getMSILMD.getGetKey(pmcl));
     
       //System.out.println(getMSILMD);
        
        getMSILMD.join(pmtm,getIMSILM);
        
        assertFalse(getMSILMD.isFunctional());
        assertTrue(getMSILMD.isMapper());
        assertTrue(getMSILMD.isDataProperty());
        assertEquals(getIMSILM, getMSILMD.getGetter(pmtm));
        assertEquals(setIMSILM, getMSILMD.getSetter(pmtm));
        assertEquals(addIMSILM, getMSILMD.getAdder(pmtm));
        assertEquals(getIKeyLM, getMSILMD.getGetKey(pmtm));
        
        
        //System.out.println(getMSILMD);
    }
    
 @Test
    public void testgetMSILO() throws J2OException {
       System.out.println("getMSILO");
       getMSILOMD = PropertyWrapperFactory.makePropertyWrapper(pmcl,getMSILOM,manager);
       assertFalse(getMSILOMD.isFunctional());
       assertTrue(getMSILOMD.isMapper());
       assertFalse(getMSILOMD.isDataProperty());
       assertEquals(getMSILOM, getMSILOMD.getGetter(pmcl));
       assertEquals(setMSILOM, getMSILOMD.getSetter(pmcl));
       assertEquals(addMSILOM, getMSILOMD.getAdder(pmcl));
       assertEquals(getKeyLOM, getMSILOMD.getGetKey(pmcl));
       
       //System.out.println(getMSILOMD);
    }
    

    
}
